/* Copyright (C) 2011, 2012, 2013 by Bundesanstalt für Gewässerkunde
 * Software engineering by Intevation GmbH
 *
 * This file is Free Software under the GNU AGPL (>=v3)
 * and comes with ABSOLUTELY NO WARRANTY! Check out the
 * documentation coming with Dive4Elements River for details.
 */

package org.dive4elements.river.model;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.List;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.SequenceGenerator;
import javax.persistence.Table;

import org.dive4elements.river.backend.SessionHolder;
import org.hibernate.Query;
import org.hibernate.Session;

@Entity
@Table(name = "annotation_types")
public class AnnotationType
implements   Serializable
{
    private Integer id;
    private String  name;

    public AnnotationType() {
    }

    public AnnotationType(final String name) {
        this.name = name;
    }

    @Id
    @SequenceGenerator(
            name           = "SEQUENCE_ANNOTATION_TYPES_ID_SEQ",
            sequenceName   = "ANNOTATION_TYPES_ID_SEQ",
            allocationSize = 1)
    @GeneratedValue(
            strategy  = GenerationType.SEQUENCE,
            generator = "SEQUENCE_ANNOTATION_TYPES_ID_SEQ")
    @Column(name = "id")
    public Integer getId() {
        return this.id;
    }

    public void setId(final Integer id) {
        this.id = id;
    }

    @Column(name = "name")
    public String getName() {
        return this.name;
    }

    public void setName(final String name) {
        this.name = name;
    }

    /**
     * Queries all annotation types from the database, orders by name
     */
    public static List<AnnotationType> getTypes() {
        final Session session = SessionHolder.HOLDER.get();
        final Query query = session.createQuery("FROM AnnotationType ORDER BY name");
        return new ArrayList<>(query.list());
    }
}
// vim:set ts=4 sw=4 si et sta sts=4 fenc=utf8 :
